Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 676942

Summary: net-misc/remmina-1.3.1 with net-libs/libvnc-0.9.12 - VNC fuzzy/garbled
Product: Gentoo Linux Reporter: Joakim Tjernlund <joakim.tjernlund>
Component: Current packagesAssignee: Diogo Pereira <sir.suriv>
Status: RESOLVED FIXED    
Severity: normal CC: alexander, bkohler, proxy-maint
Priority: Normal Keywords: PullRequest
Version: unspecified   
Hardware: All   
OS: Linux   
See Also: https://github.com/gentoo/gentoo/pull/13509
Whiteboard:
Package list:
Runtime testing required: ---
Attachments: Screenshot

Description Joakim Tjernlund 2019-01-30 18:17:40 UTC
Using Remmina and libvnc-0.9.12 I get a very garbled/fuzzy VNC connection.
If I downgrade libvncserver to 0.9.11-r1 all is good.

Somewhat odd as Remmina 1.3.1 mentions libvncserver-0.9.12 in its
rel. notes.
Comment 1 Joakim Tjernlund 2019-01-30 18:30:56 UTC
Created attachment 563330 [details]
Screenshot
Comment 2 Joakim Tjernlund 2019-01-30 18:44:26 UTC
I filed a bug upstream as well:
https://gitlab.com/Remmina/Remmina/issues/1824
Comment 3 Joakim Tjernlund 2019-01-31 23:48:44 UTC
building libvncserver with USE="-ssl gnutls" makes it work.
Comment 4 Joakim Tjernlund 2019-02-01 00:11:18 UTC
FYI remmina 1.3.2 was just released.
Comment 5 Joakim Tjernlund 2019-02-01 15:59:56 UTC
complete confusion, depending on what computer I use, libvncserver may work.
ATM, I still get the scrambled screen like the attached.
Comment 6 Ben Kohler gentoo-dev 2019-02-01 16:06:41 UTC
OK I am able to reproduce your issue.  My test setup is qemu with "-vnc :0", with remmina vnc to localhost.  I'm booting a gentoo minimal installcd and I see corruption on the "penguins" in the boot logo.

I am not able to work around the issue with USE flag manipulation, though.  I am able to work around it only by downgrading libvncserver to 0.9.11-r1.
Comment 7 Joakim Tjernlund 2019-02-01 16:10:39 UTC
(In reply to Ben Kohler from comment #6)
> OK I am able to reproduce your issue.  My test setup is qemu with "-vnc :0",
> with remmina vnc to localhost.  I'm booting a gentoo minimal installcd and I
> see corruption on the "penguins" in the boot logo.
> 
> I am not able to work around the issue with USE flag manipulation, though. 
> I am able to work around it only by downgrading libvncserver to 0.9.11-r1.

Glad to hear that, I was going nuts here.
My home computer works while work computer does not.


USE=ssl SEGVs but USE=gnutls lives
Comment 8 Joakim Tjernlund 2019-02-01 16:16:24 UTC
I also tried to add in libvncserver:
  -DCMAKE_BUILD_TYPE=Release

Mayby Remmina needs that ?
Comment 9 Ben Kohler gentoo-dev 2019-02-01 16:32:59 UTC
I did a git-bisect and narrowed the problem down to this commit on libvncserver:
https://github.com/LibVNC/libvncserver/commit/d7b14624cbb9ed7b9df3532658e1edba8da606a6
Comment 10 Joakim Tjernlund 2019-02-01 16:40:45 UTC
(In reply to Ben Kohler from comment #9)
> I did a git-bisect and narrowed the problem down to this commit on
> libvncserver:
> https://github.com/LibVNC/libvncserver/commit/
> d7b14624cbb9ed7b9df3532658e1edba8da606a6

Nice! That gave me an idea, Currently I have High Color(16bits) and
Quality Good and that corrupts.

Changing to other values makes it work, like Quality Best
Comment 11 Ben Kohler gentoo-dev 2019-02-01 16:42:25 UTC
Are both of your machines (working & non-working) using libjpeg-turbo, or does one of them have media-libs/jpeg instead?

As a side note, if I build libvncserver with USE=-jpeg, remmina segfaults, so we probably should add that USE requirement to the ebuild soon.
Comment 12 Ben Kohler gentoo-dev 2019-02-01 16:47:41 UTC
I can reproduce the issue with "quick connect" (iow I just select VNC type, and type localhost into the text entry box, and press enter), but when I manually create a new connection, I cannot seem to find a combination of settings that reproduce the problem.
Comment 13 Joakim Tjernlund 2019-02-01 16:51:41 UTC
(In reply to Ben Kohler from comment #11)
> Are both of your machines (working & non-working) using libjpeg-turbo, or
> does one of them have media-libs/jpeg instead?

At work none has media-libs/jpeg installed. Poppler will not build against it.
At home I THINK it is the same.

> 
> As a side note, if I build libvncserver with USE=-jpeg, remmina segfaults,
> so we probably should add that USE requirement to the ebuild soon.

hmm, that also feels like a bug. I first bilt remmina without vnc support
and that made remmina SEGV too when trying to connect ti my VNC server
Comment 14 Joakim Tjernlund 2019-02-01 16:52:26 UTC
(In reply to Ben Kohler from comment #12)
> I can reproduce the issue with "quick connect" (iow I just select VNC type,
> and type localhost into the text entry box, and press enter), but when I
> manually create a new connection, I cannot seem to find a combination of
> settings that reproduce the problem.

hmm, I only use saved connections.
Comment 15 Joakim Tjernlund 2019-02-01 17:01:22 UTC
(In reply to Ben Kohler from comment #11)
> Are both of your machines (working & non-working) using libjpeg-turbo, or
> does one of them have media-libs/jpeg instead?
> 
> As a side note, if I build libvncserver with USE=-jpeg, remmina segfaults,
> so we probably should add that USE requirement to the ebuild soon.

Started to install media-libs/jpeg instead but libvncsever wants
to unstall it, is libvncserver not compatible with it?
Comment 16 Joakim Tjernlund 2019-02-01 17:05:52 UTC
(In reply to Joakim Tjernlund from comment #15)
> (In reply to Ben Kohler from comment #11)
> > Are both of your machines (working & non-working) using libjpeg-turbo, or
> > does one of them have media-libs/jpeg instead?
> > 
> > As a side note, if I build libvncserver with USE=-jpeg, remmina segfaults,
> > so we probably should add that USE requirement to the ebuild soon.
> 
> Started to install media-libs/jpeg instead but libvncsever wants
> to unstall it, is libvncserver not compatible with it?

I forced media-libs/jpeg by building libvncserver with ebuild cmd instead.
It didn't help.
Both jpeg libs causes the same corruption.
Comment 17 Ben Kohler gentoo-dev 2019-09-30 20:38:42 UTC
FYI this has been fixed upstream in libvncserver: https://github.com/LibVNC/libvncserver/pull/340

If you'd like to apply this locally via /etc/portage/patches, that should fix your issue.

If there isn't a new libvncserver release soon, I can ask our maintainers to backport it.
Comment 18 Joakim Tjernlund 2019-09-30 20:47:29 UTC
(In reply to Ben Kohler from comment #17)
> FYI this has been fixed upstream in libvncserver:
> https://github.com/LibVNC/libvncserver/pull/340
> 
> If you'd like to apply this locally via /etc/portage/patches, that should
> fix your issue.
> 
> If there isn't a new libvncserver release soon, I can ask our maintainers to
> backport it.

I know, I was there :)

Already got it in /etc/portage/patches so I am good. Thanks a lot !
Comment 19 Larry the Git Cow gentoo-dev 2019-11-01 14:11:16 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5ae4ada68cdf7aa131d7a50c9305b55ba14fcd43

commit 5ae4ada68cdf7aa131d7a50c9305b55ba14fcd43
Author:     Alexander Tsoy <alexander@tsoy.me>
AuthorDate: 2019-10-31 18:41:58 +0000
Commit:     Joonas Niilola <juippis@gentoo.org>
CommitDate: 2019-11-01 14:10:59 +0000

    net-libs/libvncserver: Add a bunch of upstream fixes
    
    * fix CVE-2018-20750 (the fix for CVE-2018-15127 was incomplete)
    * fix CVE-2019-15681
    * fix libdir in pkgconfig files
    * fix regression in Tight/Raw decoding
    
    Bug: https://bugs.gentoo.org/699036
    Closes: https://bugs.gentoo.org/676942
    Closes: https://bugs.gentoo.org/691848
    Package-Manager: Portage-2.3.76, Repoman-2.3.16
    Signed-off-by: Alexander Tsoy <alexander@tsoy.me>
    Closes: https://github.com/gentoo/gentoo/pull/13509
    Signed-off-by: Joonas Niilola <juippis@gentoo.org>

 .../files/libvncserver-0.9.12-CVE-2018-20750.patch | 47 ++++++++++++++
 .../files/libvncserver-0.9.12-CVE-2019-15681.patch | 26 ++++++++
 .../files/libvncserver-0.9.12-cmake-libdir.patch   | 32 ++++++++--
 ...ibvncserver-0.9.12-fix-tight-raw-decoding.patch | 40 ++++++++++++
 .../libvncserver-0.9.12-pkgconfig-libdir.patch     | 41 ++++++++++++
 .../libvncserver/libvncserver-0.9.12-r3.ebuild     | 73 ++++++++++++++++++++++
 6 files changed, 255 insertions(+), 4 deletions(-)